/*
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

 // https://html.spec.whatwg.org/#texttrack

enum TextTrackMode { "disabled", "hidden", "showing" };
enum TextTrackKind { "subtitles", "captions", "descriptions", "chapters", "metadata", "forced" };

[
    ActiveDOMObject,
    Conditional=VIDEO,
    ExportToWrappedFunction,
    GenerateIsReachable,
    GenerateAddOpaqueRoot,
    SkipVTableValidation,
    Exposed=Window
] interface TextTrack : EventTarget {
    [ImplementedAs=kindForBindings] attribute TextTrackKind kind;
    readonly attribute DOMString label;
    [EnabledConditionallyReadWriteBySetting=MediaSourceEnabled] attribute [AtomString] DOMString language;

    readonly attribute DOMString id;
    readonly attribute DOMString inBandMetadataTrackDispatchType;

    attribute TextTrackMode mode;

    readonly attribute TextTrackCueList? cues;
    readonly attribute TextTrackCueList? activeCues;

    undefined addCue(TextTrackCue cue);
    undefined removeCue(TextTrackCue cue);

    attribute EventHandler oncuechange;

    // FIXME: Remove 'non-standard'. See: https://bugs.webkit.org/show_bug.cgi?id=260767 
    readonly attribute VTTRegionList regions;
    undefined addRegion(VTTRegion region);
    undefined removeRegion(VTTRegion region);
};
